//Delete

#include "lfn.cpp"

int all,ask;

void PrintHelp(void)
{
 #ifdef LANG_EN
  printf("This is Odi's Del for long file names %s\n",LFN_VER);
  printf("Copyright (C) 1999 Ortwin Glueck\nThis is free software under GPL. See the readme file for details.\n\n");
  printf("Usage: ldel [drive:][path]filename [/P][/A]\n\n");
  printf("Delete one or more files.\n"); 
  printf("Switches:\n");
  printf("/p\task before each file\n");
  printf("/a\tdelete also read only files\n");
  printf("/c\tdisable cache\n");
 #endif
 #ifdef LANG_DE
  printf("Odi's Del fr lange Dateinamen %s\n",LFN_VER);
  printf("Copyright (C) 1999 Ortwin Glck\nDies ist freie Software unter der GPL. Siehe readme Datei fr Details.\n\n");
  printf("LDEL [Laufwerk:][Pfad]Dateiname [/P][/A]\n\n");
  printf("Lscht Dateien.\n"); 
  printf("Optionen:\n");
  printf("/p\tvor jeder Datei fragen\n");
  printf("/a\tauch geschtzte (read-only) Dateien lschen\n");
  printf("/c\tCache abschalten\n");
 #endif
}

void ParseParams(char *arg)
{  
 int i;
 for (i=0;arg[i]=='/';i++)
 {                      
   i++;
   switch (toupper(arg[i]))
   {
    case 'H':
    case '?': PrintHelp();
              exit(1);
              break;
    case 'A': all=1;break;
    case 'P': ask=1;break; 
    case 'C': bypassCache=1;
              break;      
    case 'V': useVMCache=0;
              break;
    default:
     #ifdef LANG_EN
      printf("Invalid switch.\n");
     #endif
     #ifdef LANG_DE
      printf("Unbekannte Option.\n");
     #endif
     exit(1);
    break;
   }
 }
}

void main(int argc, char *argv[], char **envp)
{
 struct DPB Disk;        
 struct longdirentry f,dir;
 struct dirpointer dp,dp2;
 char drv,*path,*filen,*bslash,*temp,c,x[MAX_PATH_SIZE];
 int i,no;
 all=0;
 ask=0;
         
 if (argc==1)
 {
  #ifdef LANG_EN
    printf("delete which file?\n/? for help\n");
  #endif
  #ifdef LANG_DE
    printf("Sie mssen eine Datei angeben.\n/? fr Hilfe\n");
  #endif
  exit(1);         
 }
 no=argc;
 for (i=1;i<argc;i++)
 {
  if (argv[i][0]=='/')
   ParseParams(argv[i]);
  else no=i;
 }
 
 initCache();
 if (argv[no]==NULL)
 {
  #ifdef LANG_EN
    printf("delete which file?\n/? for help\n");
  #endif
  #ifdef LANG_DE
      printf("Sie mssen eine Datei angeben.\n/? fr Hilfe\n");
  #endif
  exit(1);         
 }
 drv=drive_of_path(argv[no]);
 if (makeDPB(drv,Disk)==1) exit(1);      
 if (Disk.CD==1)
 {
  #ifdef LANG_EN
    printf("CD-ROM not supported!\n");
  #endif
  #ifdef LANG_DE
    printf("CD-ROM nicht untersttzt!\n");
  #endif
  exit(1);
 }
 lockDrive(Disk.drive);
 path=seekPath(&Disk,argv[no],x,f,0); //path\file
 if (path==NULL)
 {
  #ifdef LANG_EN
   printf("File not found!\n");
  #endif
  #ifdef LANG_DE                
   printf("Datei nicht gefunden!\n");
  #endif
  exit(1);
 }
 bslash=strrchr(path,'\\')+1;
 filen=strrchr(argv[no],'\\');  // a:\filename
 if (filen==NULL)
 {
  filen=strrchr(argv[no],':'); // a:filename
  if (filen==NULL)
   filen=argv[no];
  else
   filen++;
 }
 else
  filen++;
 *bslash=0; //crop after last backslash, path is the short path to the file
 temp=seekPath(&Disk,path,x,dir,3);
 if (temp==NULL)
 { 
  #ifdef LANG_EN
    printf("Path not found!\n");
  #endif
  #ifdef LANG_DE                
    printf("Pfad nicht gefunden!\n");
  #endif
  exit(1);
 }
 free(temp);  //look up the file's path
 if (strcmp(filen,"*")==0)
 {
  #ifdef LANG_EN
   printf("Delete all files (y/n)?");
   scanf("%c",&c);
   if ((c!='Y') && (c!='y')) exit(1);
  #endif
  #ifdef LANG_DE
   printf("Alle Dateien lschen (j/n)?");
   scanf("%c",&c);
   if ((c!='J') && (c!='j')) exit(1);
  #endif
 }
 dp.cluster=dir.start_cluster; //setup search
 dp.relsector=0;
 dp.entry_no=0;
 while (1)
 {
  f=FindMask(&Disk,filen,&dp,0);
  if (f.name[0]==0) break; //no more matches
  dp2=dp;
  dp2.entry_no--;
  if ((f.atrib & (F_DIR|F_LABEL|F_HIDDEN|F_SYSTEM))==0)
  {               
   if ((all) || ((f.atrib & F_READ_ONLY)==0))
   {
    c='y';
    if (ask)
    {
     #ifdef LANG_EN
      printf("Delete '%s' (y/n)?",f.name);
      scanf("%c",&c);
      if (c=='Y') c='y';
     #endif
     #ifdef LANG_DE
      printf("'%s' lschen (j/n)?",f.name);
      scanf("%c",&c);
      if ((c=='J')  || (c=='j')) c='y';
     #endif
    }
    if (c=='y')                 
    {                                     
     if (f.start_cluster!=0) freeClusterChain(&Disk,&f);
     deleteDirentry(&Disk,&dir,&dp2,&f);
     #ifdef LANG_EN
      printf("%s deleted\n",f.name);
     #endif
     #ifdef LANG_DE
      printf("%s gelscht\n",f.name);
     #endif
    }
   }
  }
 } //endless loop
 unlockDrive(Disk.drive);
 free(path);
}
